/*
-------------------------------------------------

	NightFox's Lib Template

	Requiere DevkitARM R26
	Requiere NightFox's Lib
	Requiere EFS Lib

	Codigo por NightFox
	http://blogs.gamefilia.com/knightfox
	Inicio 10 de Octubre del 2009

	(c)2009 NightFox & Co.

-------------------------------------------------
*/



#define tilesX32 = 8
#define tilesY32 = 6


/*
-------------------------------------------------
	Includes
-------------------------------------------------
*/

// Includes c/c++
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <unistd.h>

// Includes propietarios NDS
#include <nds.h>

// Includes librerias NightFox
#include <nf_lib.h>

// Includes librerias propias
#define PULSO 5
#include "pruebas/cabecerasDepurar.h"
#include "declaraciones/pilaU8.h"
#include "declaraciones/input.h"
#include "declaraciones/colorTexto.h"
#include "declaraciones/globales.h"
#include "declaraciones/enumerados.h"
#include "declaraciones/fila.h"
#include "declaraciones/Sprite.h"
#include "declaraciones/globalText.h"
#include "declaraciones/PJText.h"
#include "declaraciones/controlSprite.h"
#include "declaraciones/Fondo.h"
Sprite s1, s2, gato;
Fondo f1,f2,f3;
#include "declaraciones/estructurasSimples.h"
#include "declaraciones/animatedBG.h"
#include "declaraciones/hablar.h"
#include "declaraciones/movimiento.h"
#include "pruebas/depurar.h"
#include "pruebas/paraProbar.h"


/*
-------------------------------------------------
	Main() - Bloque general del programa
-------------------------------------------------
*/

int main(int argc, char **argv){
	Direccion d = ninguna;
	anchoMapa = 512;
	altoMapa = 1024;
	MapaX = 0;
	MapaY = 0;
	radioCarga = 10;
	bool hablando = false;
	//char *textoHablado;

	// Pantalla de espera inicializando NitroFS
	NF_Set2D(0, 0);
	NF_Set2D(1, 0);	
	consoleDemoInit();
	iprintf("\n NitroFS init. Please wait.\n\n");
	iprintf(" Iniciando NitroFS,\n por favor, espere.\n\n");
	swiWaitForVBlank();

	// Define el ROOT e inicializa el sistema de archivos
	NF_SetRootFolder("NITROFS");	// Define la carpeta ROOT para usar NITROFS
	//chdir("hgjb,h:/");
	//sprintf(NF_ROOTFOLDER, "%s", "fat://juego");

	// Inicializa el motor 2D
	NF_Set2D(0, 0);				// Modo 2D_0 en ambas pantallas
	NF_Set2D(1, 0);

	// Inicializa los fondos tileados
	NF_InitTiledBgBuffers();	// Inicializa los buffers para almacenar fondos
	NF_InitTiledBgSys(0);		// Inicializa los fondos Tileados para la pantalla superior
	NF_InitTiledBgSys(1);		// Iniciliaza los fondos Tileados para la pantalla inferior
	NF_InitCmapBuffers();	// Inicializa los mapas de colision
	
	NF_InitSpriteBuffers();		// Inicializa los buffers para almacenar sprites y paletas
	NF_InitSpriteSys(0);		// Inicializa los sprites para la pantalla superior
	NF_InitSpriteSys(1);		// Inicializa los sprites para la pantalla inferior


	//iniciaFondo();
	//cargaFondo();
	iniciaFondos();
	cargaFondos();

	iniciaTexto();
	//iniciaTexto2();
	//InicializaCapaTexto();

	

	iniciaSpriteConDependencia();
	pruebaSpriteConDependencia();
	//
	//gato
	iniciaSpriteSinDependencia();
	pruebaSpriteSinDependencia();

	defTiles = f1.defTiles;

	ocuparSpriteMapaColision(s1,0);
	ocuparSpriteMapaColision(gato,0);
	
	/*s8 alpha = 5;
	REG_BLDCNT_SUB = BLEND_ALPHA | BLEND_SRC_SPRITE | BLEND_DST_BG1 | BLEND_DST_BG0 | BLEND_DST_BG2 | BLEND_DST_BG3;
	REG_BLDALPHA_SUB = (15-alpha)<< 8 | alpha;
	oamSub.oamMemory[0].attribute[0] = ATTR0_NORMAL | ATTR0_TYPE_BLENDED | ATTR0_COLOR_256 | ATTR0_SQUARE | 150;
	oamSub.oamMemory[1].attribute[2] = ATTR2_ALPHA(15);*/
/*	char msg[128];
	char *nombre = new char[PersonalData->nameLen + 1];
	for (int i=0;i<PersonalData->nameLen;i++){
		nombre[i] = (char)PersonalData->name[i];
	}
	nombre[PersonalData->nameLen] = '\0';
	sprintf(msg,"[c=000000]Tamanyo nombre: %d\nNombre: %s[/c]",PersonalData->nameLen,nombre);
	escribeDepurando2(msg,1);*/
	s8 alpha = 10;
	REG_BLDCNT_SUB = BLEND_ALPHA | BLEND_SRC_BG2 | BLEND_DST_SPRITE | BLEND_DST_BG0 | BLEND_DST_BG1 | BLEND_DST_BG3;
	REG_BLDALPHA_SUB = (15-alpha)<< 8 | alpha;
	AnimatedBG fAnimado = AnimatedBG(f2);

	while(1) {
		ReadKeyPad();

		//muestraMapaColision();
		//muestraMapaAgua();
		//muestraVariables();
		//IndicaColision();
		//muestraTiempoPulsados();
		fAnimado.animar();
		if (!hablando){
			registraMovimiento();
			hablando = compruebaHablar();
			d = s1.movimiento.getPasoN(32);
			realizaMovimiento(d);
			mueveGato();
			NF_SpriteOamSet(1);
		}else{
			hablando = continuaConversacionCon();
		}


		swiWaitForVBlank();		// Espera al sincronismo vertical
		if (!hablando){
			// Actualiza el OAM
			oamUpdate(&oamSub);

			moverMapa(d,s1);
		}
	}

	return 0; 

}
